@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:enum_fb_device
    set _device_list=
    set DEVICE_COUNT=0
    set device_timeout=0
    set remain_time=0
    set wait_time=60
    set DEVICE_LIST=

    call :view_fb_not_adb_tips
    :enumerate_fb_loop
    for /F "usebackq tokens=1" %%X in (`%%fastboot%% devices`) do (
        REM if device connected
        if "%%X" NEQ "" (
            set /A DEVICE_COUNT+=1
            set _device_list=!_device_list! %%X
        )
    )

    REM device not connected
    if "%_device_list%" == "" (
        set /A device_timeout+=1
        set /A remain_time=!wait_time! - !device_timeout!
        if !device_timeout! == !wait_time! (
            call :view_device_connect_timeout
            goto :tips
        )
        call :view_device_connetct_waitingfor !remain_time!
        ping 127.0.1 -n 2 >nul 2>nul
        goto :enumerate_fb_loop
    )

    for /F "usebackq tokens=*" %%X in (`echo %%_device_list%% ^| %%awk%% "{$1=$1; print}"`) do (
        set DEVICE_LIST=%%X
    )

    call :view_fb_device_conn %DEVICE_COUNT% %DEVICE_LIST%

    call :view_currect_fastboot_in_use
    %fastboot% --version
    set _device_list=
    set wait_time=
    set device_timeout=
    set remain_time=
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_fb_not_adb_tips
    echo.
    echo Note: Fastboot commands can only used in Fastboot mode. ADB is not Fastboot, Fastboot is certainly not ADB.
exit /b 0
::
:finding_fb_device
    echo.
    echo Finding Fastboot device...
exit /b 0
::
:view_device_connetct_waitingfor
    echo.
    echo ==^> Waiting for device to connect. [%1] seconds remaining.
exit /b 0
::
:view_device_connect_timeout
    color fc
    echo.
    echo [Fatal] Connection timed out. Please check your device connection.
exit /b 0
::
:view_fb_device_conn
    echo.
    echo Currently %1 Fastboot devices connected: [%2]
exit /b 0
::
:view_currect_fastboot_in_use
    echo.
    echo [Debug] The fastboot version currently in use:
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo Press any key to exit.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
