@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_flash_diy
call :view_menu_flash_diy_t
@title %title_name%
color f9
    call :view_menu_flash_diy
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && call :sub_run_diy_erase 1
    if "%selection%"=="2" cls && call :sub_run_diy_flash 2
    if "%selection%"=="3" cls && call :sub_run_diy_by_me
    if "%selection%"=="0" cls && exit /b 0
    cls
goto :menu_flash_diy
exit /b 0
::
::
:sub_run_diy_erase
call :view_sub_run_diy_erase_t
@title %title_name%
    call :view_diy_erase_tips

    call :input_partition_name

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_flash_diy_action_single.cmd" %1
            ) else (
                start cmd /k call "%~dp0run_flash_diy_action_single.cmd" %1
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_menu_diy
    pause > nul
exit /b 0
::
::
:sub_run_diy_flash
call :view_sub_run_diy_flash_t
@title %title_name%
    call :view_diy_flash_tips
    call :input_partition_name

    call :view_diy_flash_input_file_name_tips
    call :input_flash_file

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_flash_diy_action_single.cmd" %1
            ) else (
                start cmd /k call "%~dp0run_flash_diy_action_single.cmd" %1
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_menu_diy
    pause > nul
exit /b 0
::
::
:input_partition_name
    call :view_input_partition_name
    set FLAG_TARGET_PARTITION_NAME=
    set /p FLAG_TARGET_PARTITION_NAME=
    if "%FLAG_TARGET_PARTITION_NAME%" == "" (
        call :view_wrong_enter_wrong_tip
        ping 127.0.1 -n 2 >nul 2>nul
        goto :input_partition_name
    )
exit /b 0
::
::
:input_flash_file
    call :view_input_flash_file
    set FLAG_TARGET_FILE=
    set /p FLAG_TARGET_FILE=
    if "%FLAG_TARGET_FILE%" == "" (
        call :view_wrong_enter_wrong_tip
        ping 127.0.1 -n 2 >nul 2>nul
        goto :input_flash_file
    )
    if not exist "%FLAG_TARGET_FILE%" (
        call :view_wrong_enter_wrong_tip
        ping 127.0.1 -n 2 >nul 2>nul
        goto :input_flash_file
    )
exit /b 0
::
::
:sub_run_diy_by_me
    if exist "%TFS_ROOT%tools\bin\cmd.bat" (
        start "" "%TFS_ROOT%tools\bin\cmd.bat"
    ) else (
        call :view_cmdbat_file_not_found
        ping 127.0.1 -n 2 >nul 2>nul
    )
    goto :exit
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_flash_diy
    echo.--------------------------------------------------------------------------------
    echo. [1] Erase a partition                           [2] Flash a partition
    echo.
    echo. [3] Exit flash tool, Manually execute fastboot commands
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo.--------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_diy_erase_tips
    echo ================================================================================
    echo     Usage:
    echo ================================================================================
    echo. [*] Enter the partition name directly, and press Enter.
    echo.
    echo.-------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_diy_flash_tips
    echo ================================================================================
    echo  Usage:
    echo ================================================================================
    echo. [*] Please enter the name of this partition first, and then enter the image
    echo. [*] location path ^(You can directly drag the image to this window^).
    echo. [*] The directory name cannot contain spaces or special characters^^!
    echo.
    echo -------------------------------------------------------------------------------
    echo.
    echo [-] Note: Please enter the name of the partition to be flashed.
exit /b 0
::
:view_diy_flash_input_file_name_tips
    echo.
    echo [-] Note: Please enter the image location path, or directly drag the image to this window.
exit /b 0
::
:view_menu_flash_diy_t
    set title_name=%title% %version% - DIY Menu
exit /b 0
::
:view_sub_run_diy_erase_t
    set title_name=%title% %version% - DIY Menu ^( Erase Partition ^)
exit /b 0
::
:view_sub_run_diy_flash_t
    set title_name=%title% %version% - DIY Menu ^( Flash partition ^)
exit /b 0
::
:view_press_key_num
    echo|set /p="Please enter the option number: >>"
exit /b 0
::
:view_input_partition_name
    echo.
    echo|set /p="Please enter the partition name and press Enter: >>"
exit /b 0
::
:view_input_flash_file
    echo.
    echo|set /p="Please enter the image location and press Enter: >>"
exit /b 0
::
:view_wrong_enter_wrong_tip
    echo Input error, please try again.
exit /b 0
::
:view_cmdbat_file_not_found
    color fc
    echo.
    echo [Fatal] cmd.bat file not found^^!
exit /b 0
::
:view_processing_device
    echo.
    echo Processing device: [%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [Fatal] Device list not found^^!
exit /b 0
::
:view_press_any_key_return_menu_diy
    echo.
    echo Flash completed. Press any key to return to the DIY menu.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit
exit
