@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:sub_run_flash_bl
call :view_sub_run_flash_bl_t
@title %title_name%

    call :view_flash_bl_tips
    call :view_press_key_continue

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_flash_bl_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_flash_bl_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_main_menu
    pause > nul
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_sub_run_flash_bl_t
    set title_name=%title% %version% - Flash Menu ^( Flash BL Part ^)
exit /b 0
::
:view_flash_bl_tips
    echo ================================================================================
    echo                                          NOTE:
    echo ================================================================================
    echo. [*] This operation will flashing the Bootloader Part^(BL^). If it not necessary, no need to flash it.
    echo. [*] Flash a wrong Bootloader, it may cause the device hard brick and no way to recover.
    echo.
    echo. [*] GPT image / BL Part / BP Part can only be upgrade or flash same version, can't downgrade.
    echo Flash a higher firmware version than the device will cause the device no ability restore to the old version^^!
    echo.
    echo +++++ Please make sure that you can solve the problem after it occurs before performing this operation.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_press_key_continue
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul
exit /b 0
::
:view_processing_device
    echo.
    echo Processing device: [%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [Fatal] Device list not found^^!
exit /b 0
::
:view_press_any_key_return_main_menu
    echo.
    echo Press any key to return to the Main menu.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit
exit
