@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_adb_action
call :view_menu_adb_action_t
@title %title_name%
color f9
    call :view_menu_adb_action
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%" == "1" cls && call :sub_run_adb_action !selection!
    if "%selection%" == "2" cls && call :sub_run_adb_action !selection!
    if "%selection%" == "3" cls && call :sub_run_adb_action !selection!
    if "%selection%" == "0" cls && exit /b 0
    cls
goto :menu_adb_action
::
::
:sub_run_adb_action
    set FLAG_ADB_ACTION_OPT=

    if "%1" == "1" (
        set FLAG_ADB_ACTION_OPT=remove-frp
        call :show_remove_frp_tips
        goto :end_show_action_tips
    )
    if "%1" == "2" (
        set FLAG_ADB_ACTION_OPT=remove-exclamation
        call :show_remove_exclamation_tips
        goto :end_show_action_tips
    )
    if "%1" == "3" (
        set FLAG_ADB_ACTION_OPT=set-china-ntp
        call :show_set_china_ntp_server_tips
        goto :end_show_action_tips
    )
    call :view_unknown_opt
    goto :end_run_adb_action

    :end_show_action_tips
    call "%~dp0do_kill_adb_server.cmd"

    call "%~dp0enumerate_adb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_adb_action_single.cmd" !FLAG_ADB_ACTION_OPT!
            ) else (
                start cmd /k call "%~dp0run_adb_action_single.cmd" !FLAG_ADB_ACTION_OPT!
            )

        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    :end_run_adb_action
    call :view_press_any_key_return_menu_adb_action
    pause >nul

    call "%~dp0do_kill_adb_server.cmd"

exit /b 0
::
::
:show_remove_frp_tips
call :view_show_remove_frp_tips_t
@title %title_name%
    call :view_remove_frp_tips
    call :view_press_key_continue
exit /b 0
::
::
:show_remove_exclamation_tips
call :view_show_remove_exclamation_tips_t
@title %title_name%
    call :view_remove_exclamation_tips
    call :view_press_key_continue
exit /b 0
::
::
:show_set_china_ntp_server_tips
call :view_set_china_ntp_server_tips_t
@title %title_name%
    call :view_set_china_ntp_server_tips
    call :view_press_key_continue
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_adb_action_t
    set title_name=%title% %version% - ADB Menu
exit /b 0
::
:view_show_remove_frp_tips_t
    set title_name=%title% %version% - Remove Google Factory Reset Protect ^(FRP^)
exit /b 0
::
:view_show_remove_exclamation_tips_t
    set title_name=%title% %version% - Remove exclamation on the singal icon
exit /b 0
::
:view_set_china_ntp_server_tips_t
    set title_name=%title% %version% - Setup China NTP Server
exit /b 0
::
:view_menu_adb_action
    echo.--------------------------------------------------------------------------------
    echo. [1] Remove Google Factory Reset Protect ^(FRP^)
    echo. [2] Android 5.0+ Remove exclamation on the signal icon
    echo. [3] Setup China NTP Server
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo.--------------------------------------------------------------------------------
exit /b 0
::
:view_press_key_num
    echo|set /p="Please enter the option number: >>"
exit /b 0
::
:view_press_key_continue
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul
exit /b 0
::
:view_remove_frp_tips
    echo --------------------------------------------------------------------------------
    echo. [*] You must be let device normal boot up, enable USB Debugging and check "Always allow from this comuter".
    echo. [*] If you don't know how to enable USB Debugging, please Google that.
    echo. [*] When you remove FRP complete, please restart the device to take effect.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_remove_exclamation_tips
    echo --------------------------------------------------------------------------------
    echo. [*] You must be let device normal boot up, enable USB Debugging and check "Always allow from this comuter".
    echo. [*] If you don't know how to enable USB Debugging, please Google that.
    echo. [*] When you remove exclamation complete, turn on airplane mode and then turn it off to take effect.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_set_china_ntp_server_tips
    echo --------------------------------------------------------------------------------
    echo. [*] You must be let device normal boot up, enable USB Debugging and check "Always allow from this comuter".
    echo. [*] If you don't know how to enable USB Debugging, please Google that.
    echo. [*] When you remove FRP complete, please restart the device to take effect.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_unknown_opt
    color fc
    echo.
    echo Unknown Opt.
exit /b 0
::
:view_processing_device
    echo.
    echo Processing device: [%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [Fatal] Device list not found^^!
exit /b 0
::
:view_press_any_key_return_menu_adb_action
    echo.
    echo Press any key to return to the ADB menu.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
