@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_global_config
call :view_menu_global_config_t
@title %title_name%
color f9
    call :view_menu_global_config
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && call "%~dp0menu_set_mfastboot.cmd" && exit /b 0
    if "%selection%"=="2" cls && call :set_reboot_bl_when_flash_all
    if "%selection%"=="3" cls && call :set_reboot_after_flash_all_finished
    if "%selection%"=="0" cls && exit /b 0
    cls
goto :menu_global_config
::
::
:set_reboot_bl_when_flash_all
call :view_set_reboot_bl_when_flash_all_t
@title %title_name%
    call :view_reboot_bl_when_flash_all_tips
    call :input_reboot_bl_when_flash_all
    if "%FLAG_REBOOT_BL_WHEN_FLASH_ALL%" == "y" (
        set flashall_skip_reboot_bl=0
    )
    if "%FLAG_REBOOT_BL_WHEN_FLASH_ALL%" == "n" (
        set flashall_skip_reboot_bl=1
    )
    call :view_write_config_file
    %sed% -i "s@ flashall_skip_reboot_bl=.*@ flashall_skip_reboot_bl=%flashall_skip_reboot_bl%@g" "%TFS_ROOT%tools\config\config.cmd"
    call "%TFS_ROOT%tools\config\config.cmd"
    color f2
    call :view_action_finished
    ping 127.0.1 -n 2 >nul 2>nul
exit /b 0
::
::
:set_reboot_after_flash_all_finished
call :view_set_reboot_after_flash_all_finished_t
@title %title_name%
    call :view_reboot_after_flash_all_finished_tips
    call :input_reboot_after_flash_all_finished
    if "%FLAG_REBOOT_AFTER_FLASH_ALL_FINISHIED%" == "y" (
        set flashall_finished_reboot=1
    )
    if "%FLAG_REBOOT_AFTER_FLASH_ALL_FINISHIED%" == "n" (
        set flashall_finished_reboot=0
    )
    call :view_write_config_file
    %sed% -i "s@ flashall_finished_reboot=.*@ flashall_finished_reboot=%flashall_finished_reboot%@g" "%TFS_ROOT%tools\config\config.cmd"
    call "%TFS_ROOT%tools\config\config.cmd"
    color f2
    call :view_action_finished
    ping 127.0.1 -n 2 >nul 2>nul
exit /b 0
::
::
:input_reboot_bl_when_flash_all
    call :view_input_reboot_bl_when_flash_all_yn
    set opt=
    set /p opt=
    if /i "%opt%" == "y" cls && set "FLAG_REBOOT_BL_WHEN_FLASH_ALL=y" && exit /b 0
    if /i "%opt%" == "n" cls && set "FLAG_REBOOT_BL_WHEN_FLASH_ALL=n" && exit /b 0
goto :input_reboot_bl_when_flash_all
::
::
:input_reboot_after_flash_all_finished
    call :view_input_reboot_after_flash_all_finished_yn
    set opt=
    set /p opt=
    if /i "%opt%"=="y" cls && set "FLAG_REBOOT_AFTER_FLASH_ALL_FINISHIED=y" && exit /b 0
    if /i "%opt%"=="n" cls && set "FLAG_REBOOT_AFTER_FLASH_ALL_FINISHIED=n" && exit /b 0
goto :input_reboot_after_flash_all_finished
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_global_config_t
    set title_name=%title% %version% - Global Configuration
exit /b 0
::
:view_set_reboot_bl_when_flash_all_t
    set title_name=%title% %version% - Don't reboot the Bootloader during flashing full firmware
exit /b 0
::
:view_set_reboot_after_flash_all_finished_t
    set title_name=%title% %version% - Reboot after flashing the full firmware
exit /b 0
::
:view_menu_global_config
    echo --------------------------------------------------------------------------------
    echo. [1] Change the default Fastboot version
    echo. [2] Don't reboot the Bootloader during flashing full firmware [%flashall_skip_reboot_bl%]
    echo. [3] Reboot after flashing the full firmware [%flashall_finished_reboot%]
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo --------------------------------------------------------------------------------
exit /b 0
::
:view_press_key_num
    echo|set /p="Please enter the option number: >>"
exit /b 0
::
:view_input_reboot_bl_when_flash_all_yn
    echo|set /p="Do you need to restart BL during flashing full firmware? (Y/N) >>"
exit /b 0
::
:view_input_reboot_after_flash_all_finished_yn
    echo|set /p="Do you need to reboot after the full firmware flashing is complete? (Y/N) >>"
exit /b 0
::
:view_reboot_bl_when_flash_all_tips
    echo --------------------------------------------------------------------------------
    echo. [*] During flashing of the full firmware, reboot the Bootloader after flashing the BL part.
    echo This will make the device apply the new Bootloader,
    echo and automatically switch to slot A to complete the next flashing steps.
    echo If you don't need to reboot the bootloader during flashing full firmware, you can turn it off.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_reboot_after_flash_all_finished_tips
    echo --------------------------------------------------------------------------------
    echo. [*] When the full firmware flashing is complete, reboot into the system
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_write_config_file
    echo.
    echo ==^> Writing configuration file...
exit /b 0
::
:view_action_finished
    echo.
    echo Action Done.
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo Press any key to exit.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
