@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_set_mfastboot
call :view_menu_set_mfastboot_version_t
@title %title_name%
    call :view_menu_set_mfastboot
    call :view_press_key_num
    set selection=
    set /p selection=
    if /i "%selection%"=="1" cls && call :set_mfastboot_ver 34.0.4 && exit /b 0
    if /i "%selection%"=="2" cls && call :set_mfastboot_ver 28.0.2 && exit /b 0
    if /i "%selection%"=="3" cls && call :set_mfastboot_ver 26.0.0 && exit /b 0
    if /i "%selection%"=="4" cls && call :set_fastboot_as_default  && exit /b 0
    if /i "%selection%"=="0" cls && exit /b 0
    cls
goto :menu_set_mfastboot
::
::
:set_mfastboot_ver
    call :view_write_config_file
    %sed% -i "s@ fastboot=.*@ fastboot=\"%%TFS_ROOT%%tools\\mfastboot\\%1\\mfastboot.exe\"@g" "%TFS_ROOT%tools\config\config.cmd"
    %sed% -i "s@ PATH=.*@ PATH=%%PATH%%;\"%%~dp0\";\"%%~dp0..\\..\\\";\"%%~dp0..\\mfastboot\\%1\"@g" "%TFS_ROOT%tools\bin\cmd.bat"
    pause
    call "%TFS_ROOT%tools\config\config.cmd"
    color f2
    call :view_action_finished
    ping 127.0.1 -n 3 >nul 2>nul
    cls
exit /b 0
::
::
:set_fastboot_as_default
    call :view_write_config_file
    %sed% -i "s@ fastboot=.*@ fastboot=\"%%TFS_ROOT%%tools\\bin\\fastboot.exe\"@g" "%TFS_ROOT%tools\config\config.cmd"
    call "%TFS_ROOT%tools\config\config.cmd"
    color f2
    call :view_action_finished
    ping 127.0.1 -n 3 >nul 2>nul
    cls
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_set_mfastboot_version_t
    set title_name=%title% %version% - Please Choose the Fastboot version
exit /b 0
::
:view_menu_set_mfastboot
    echo --------------------------------------------------------------------------------
    echo. [*] Default to use the latest Motorola fastboot, but the new version may cause problems on old devices.
    echo.
    echo. [#] For old devices released before 2018, please be sure to use the old version ^(26.0.0^)
    echo. [#] In 2019-2020, devices running Android 9-10, you can use version 28.0.2
    echo. [#] After 2020, devices running Android 11+, please use version 34.0.4
    echo.
    echo. [*] You can change the Fastboot version anytime by pressing "F" in the Main menu.
    echo.
    echo. [^^!^^!^^!] Do NOT try to use the Google fastboot on Motorola devices ^(no compatible^)^^!
    echo.
    echo Please Choose the Fastboot version:
    echo -------------------------------------------------------------------------------
    echo. [1] Motorola fastboot 34.0.4 ^(Default^)      [2] Motorola fastboot 28.0.2
    echo. [3] Motorola fastboot 26.0.0
    echo. [4] Latest Google fastboot ^(No compatible Motorola devices^) ^(34.0.5^)
    echo.
    echo. [0] Return to the Main menu ^(No change settings^)
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_press_key_num
    echo|set /p="Please enter the option number: >>"
exit /b 0
::
:view_write_config_file
    echo.
    echo ==^> Writing configuration file...
exit /b 0
::
:view_action_finished
    echo.
    echo Action Done.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit
exit
