@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_switch_slot
call :view_menu_switch_slot_t
@title %title_name%
color f9
    call :view_menu_switch_slot
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && call :sub_run_switch_slot !selection! && exit /b 0
    if "%selection%"=="2" cls && call :sub_run_switch_slot !selection! && exit /b 0
    if "%selection%"=="0" cls && exit /b 0
    cls
goto :menu_switch_slot
exit /b 0
::
::
:sub_run_switch_slot
    set FLAG_SWITCH_SLOT_OPT=
    if "%1" == "1" (
        set FLAG_SWITCH_SLOT_OPT=a
        goto :end_slot_opt_set
    )
    if "%1" == "2"  (
        set FLAG_SWITCH_SLOT_OPT=b
        goto :end_slot_opt_set
    )
    set FLAG_SWITCH_SLOT_OPT=a
    :end_slot_opt_set

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_switch_slot_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_switch_slot_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_main_menu
    pause > nul
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_switch_slot_t
    set title_name=%title% %version% - Switch Slot Menu
exit /b 0
::
:view_menu_switch_slot
    echo --------------------------------------------------------------------------------
    echo. [*] Only the models released after 2017 and the models with the design of the A/B partitions can change slots.
    echo. [*] Only when the BL is unlocked, the A/B slot can be changed.
    echo. [*] If your device does not unlock BL, you should flashing the BL part of the current firmware
    echo and reboot fastboot then you can change back Slot A.
    echo. [*] If your device's Slot B BL is empty, forcibly changing may cause the device brick or re-lock BL again^^!
    echo. [*] Please make sure you have flashed in the copy-partitions.zip via TWRP before changing!
    echo The copy-partitions.zip will completely copy the BL of slot A to slot B to prevent your device brick.
    echo.
    echo. [1] Change to Slot A
    echo. [2] Change to Slot B
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_press_key_num
    echo|set /p="Please enter the option number: >>"
exit /b 0
::
:view_processing_device
    echo.
    echo Processing device: [%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [Fatal] Device list not found^^!
exit /b 0
::
:view_press_any_key_return_main_menu
    echo.
    echo Press any key to return to the Main menu.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
