@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menu_unlock_bl
call :view_menu_unlock_bl_t
@title %title_name%
color f9
    call :view_menu_unlock_bl
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && set "FLAG_UNLOCK_BL_OPT=!selection!" && call :sub_run_unlock_bl !selection!
    if "%selection%"=="2" cls && set "FLAG_UNLOCK_BL_OPT=!selection!" && call :sub_run_unlock_bl !selection!
    if "%selection%"=="3" cls && call :sub_run_unlock_bl_moto
    if "%selection%"=="4" cls && call :sub_run_get_device_id
    if "%selection%"=="0" cls && exit /b 0
    cls
goto :menu_unlock_bl
::
::
:sub_run_unlock_bl
call :view_sub_run_unlock_bl_t
@title %title_name%
color f9
    if "%1" == "1" (
        call :view_unlock_bl_generic_tips
        goto :end_show_unlock_tips
    )
    if "%1" == "2" (
        call :view_unlock_bl_generic_tips
        goto :end_show_unlock_tips
    )
    if "%1" == "3" (
        call :view_unlock_bl_mot_tips
        goto :end_show_unlock_tips
    )

    :end_show_unlock_tips
    call :view_press_key_continue

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_flashing_unlock_single.cmd" %1
            ) else (
                start cmd /k call "%~dp0run_flashing_unlock_single.cmd" %1
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_menu_unlock_bl
    pause > nul
exit /b 0
::
::
:sub_run_unlock_bl_moto
call :view_sub_run_unlock_bl_moto_t
@title %title_name%
color f9
    call :view_unlock_bl_mot_tips
    call :view_press_key_continue

    call "%~dp0enumerate_fb_devices.cmd"

    if "!DEVICE_COUNT!" GTR "1" (
        call :input_read_code_from_file
        if "!FLAG_READ_CODE_FROM_FILE!" == "1" (
            goto :manual_input_code
        )

    )

    :manual_input_code
    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_oem_unlock_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_oem_unlock_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
    goto :unlock_bl_end

    :read_code_from_file
    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_oem_unlock_unlockcode_single.cmd" unlockcode.txt
            ) else (
                start cmd /k call "%~dp0run_oem_unlock_unlockcode_single.cmd" unlockcode.txt
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    :unlock_bl_end
    call :view_press_any_key_return_menu_unlock_bl
    pause > nul
exit /b 0
::
::
:sub_run_get_device_id
call :view_sub_run_get_device_id_t
@title %title_name%
color f9

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_get_device_id_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_get_device_id_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    if "%DEVICE_COUNT%" == "1" (
        goto :menu_get_device_id
    )

    call :view_press_any_key_return_menu_unlock_bl
    pause > nul
exit /b 0
::
::
:menu_get_device_id
    call :view_menu_get_device_id
    call :view_press_key_num
    set selection=
    set /p selection=
    if "%selection%"=="1" cls && start "" "https://motorola-global-portal.custhelp.com/app/standalone/bootloader/unlock-your-device-b" >nul 2>nul && goto :menu_get_device_id
    if "%selection%"=="2" cls && call :sub_run_get_device_id
    if "%selection%"=="3" cls && exit /b 0 && exit /b 0
    if "%selection%"=="0" cls && exit /b 0 && exit /b 0 && exit /b 0
    cls
    goto :menu_get_device_id
exit /b 0
::
::
:input_read_code_from_file
    set FLAG_READ_CODE_FROM_FILE=0
    call :view_input_read_code_from_file
    set selection=
    set /p selection=
    if "%selection%"=="y" && set "FLAG_READ_CODE_FROM_FILE=1" exit /b 0
    if "%selection%"=="n" && set "FLAG_READ_CODE_FROM_FILE=0" exit /b 0
    goto :input_read_code_from_file
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_menu_unlock_bl_t
    set title_name=%title% %version% - Bootlader Unlock Menu
exit /b 0
::
:view_sub_run_unlock_bl_t
    set title_name=%title% %version% - Bootlader Unlock Menu ^( Unlock BOOTLOADER ^)
exit /b 0
::
:view_sub_run_unlock_bl_moto_t
    set title_name=%title% %version% - Bootlader Unlock Menu ^( Unlock MOTOROLA BOOTLOADER ^)
exit /b 0
::
:view_sub_run_get_device_id_t
    set title_name=%title% %version% - Bootlader Unlock Menu ^( Get Device ID ^)
exit /b 0
::
:view_menu_unlock_bl
    echo --------------------------------------------------------------------------------
    echo. [1] Unlock Bootloader for general Android devices ^(flashing unlock^)
    echo. [2] Unlock Bootloader for general Android devices ^(oem unlock, legacy^)
    echo.
    echo. [3] Unlock Bootloader for Motorola devices ^(oem unlock, Unlock code required^)
    echo. [4] Get Device ID ^(get_unlock_data^)
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo --------------------------------------------------------------------------------
    echo.
    ::
exit /b 0
::
:view_press_key_num
    echo|set /p="Please enter the option number: >>"
exit /b 0
::
:view_input_read_code_from_file
    echo|set /p="Read unlock code from unlockcode.txt? (Y/N) >>"
exit /b 0
::
:view_unlock_bl_generic_tips
    echo ================================================================================
    echo                                          NOTE:
    echo ================================================================================
    echo. [*] This operation will erase all user data, including installed applications, media, files on the internal storage, etc.
    echo. [*] Please enable "OEM unlock" option in Settings -^> System -^> Developer options first, then you can unlock the bootloader.
    echo. [*] After unlocking the Bootloader, it means that you have lost the official warranty, and a warning will be displayed every time you boot.
    echo.
    echo. [*] Please press the volume key, select "UNLOCK THE BOOTLOADER" option, and then press the power button to confirm unlock BL.
    echo -------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_unlock_bl_mot_tips
    echo ================================================================================
    echo                                          NOTE:
    echo ================================================================================
    echo. [*] This operation will erase all user data, including installed applications, media, files on the internal storage, etc.
    echo. [*] Please enable "OEM unlock" option in Settings -^> System -^> Developer options first, then you can unlock the bootloader.
    echo. [*] After unlocking the Bootloader, it means that you have lost the official warranty, and a warning will be displayed every time you boot.
    echo.
    echo. [*] Please press the volume key, select "UNLOCK THE BOOTLOADER" option, and then press the power button to confirm unlock BL.
    echo -------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_menu_get_device_id
        echo --------------------------------------------------------------------------------
        echo Unlocking steps:
        echo. [*] 1. Open Motorola Unlocking the bootloader website, then login Motorola or Google account;
        echo. [*] 2. Enter your Device ID to input box, and click "Can my device be unlocked" button;
        echo. [*] 3. If your device can be unlocked, Click "Request Unlock Key" button.
        echo When finished, unlock code will be sent to your mailbox.
        echo.
        echo. [*] NOTE: some US carriers, Eg. Verizon / AT^&T, can't be unlock Bootloader,
        echo Website will alert you "Your device does not qualify for bootloader unlocking".
        echo.
        echo. [1] Open Motorola Unlocking the bootloader website
        echo. [2] Refetch Device ID
        echo. [3] ^<^< Return to the BootLoader Unlock menu
        echo. [0] ^<^<^< Return to the Main menu
        echo --------------------------------------------------------------------------------
        echo.
exit /b 0
::
:view_press_key_continue
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul
exit /b 0
::
:view_processing_device
    echo.
    echo Processing device: [%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [Fatal] Device list not found^^!
exit /b 0
::
:view_press_any_key_return_menu_unlock_bl
    echo.
    echo Please press any key to return to the Bootloader Unlock menu.
exit /b 0
::
:view_press_any_key_return_main_menu
    echo.
    echo Press any key to return to the Main menu.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit
exit
