@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

@SETLOCAL enabledelayedexpansion

:run_flash_ap_single
color f9
call :view_run_flash_ap_single_t
@title %title_name%
    set /A failure_count=0
    set /A total_failure_count=0

    call "%~dp0get_partition_table.cmd"

    if "%FLAG_DEVICE_GPT_DAMAGED%" == "1" (
        call :view_device_gpt_damaged_tips
        exit /b 1
    )

    call :view_flash_ap_title

    call :run_oem_fb_mode_set

    if "%FLAG_DEVICE_IS_QCOM%" == "1" (
        call "%~dp0do_flash_ap_qcom.cmd"
        set /A total_failure_count+=!failure_count!
        goto :end_flash_device_spec
    )

    if "%FLAG_DEVICE_IS_MTK%" == "1" (
        call "%~dp0do_flash_ap_mtk.cmd"
        set /A total_failure_count+=!failure_count!
        goto :end_flash_device_spec
    )

    if "%FLAG_DEVICE_IS_SLSI%" == "1" (
        call "%~dp0do_flash_ap_mtk.cmd"
        set /A total_failure_count+=!failure_count!
        goto :end_flash_device_spec
    )

    :end_flash_device_spec

    call "%~dp0do_flash_ap_generic.cmd"
    set /A total_failure_count+=%failure_count%

    call :run_oem_fb_mode_clear

    if %total_failure_count% == 0 ( color f2 )

    call :view_flash_ap_footer %serial_number% %total_failure_count%

    if "%DEVICE_COUNT%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:run_oem_fb_mode_set
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_set_tips
        !fastboot! -s !serial_number! oem fb_mode_set
    )
exit /b 0
::
::
:run_oem_fb_mode_clear
    if "%FLAG_DEVICE_USE_MOT_OEM_FASTBOOT%" == "1" (
        call :view_fb_mode_clear_tips
        !fastboot! -s !serial_number! oem fb_mode_clear
    )
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_run_flash_ap_single_t
    set title_name=%title% %version% - Flashing AP [%serial_number%]
exit /b 0
::
:view_fb_mode_set_tips
    echo.
    echo ==^> Set FB Mode...
exit /b 0
::
:view_fb_mode_clear_tips
    echo.
    echo ==^> Clear FB Mode...
exit /b 0
::
:view_device_gpt_damaged_tips
    color fc
    echo.
    echo Fatal Error: The current GPT partition table is damaged and the slot information cannot be read^^!
    echo Please try to flash the GPT image first or try to switch slots manually^^!
exit /b 0
::
:view_flash_ap_title
    echo.
    echo ======== Flashing AP ^( Android OS Part ^) ========
exit /b 0
::
:view_flash_ap_footer
    echo.
    echo Device [%1] AP ^( Android OS Part ^) Flashing completed. There were %2 total errors.
exit /b 0
::
:view_press_any_key_exit
    echo.
    echo Press any key to exit.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:tips
    call :view_press_any_key_exit
    pause > nul
::
::
:exit
exit
