@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:sub_run_flash_recovery
call :view_sub_run_flash_recovery_t
@title %title_name%
    call :view_flash_recovery_tips
    call :view_press_key_continue

    set FLAG_FLASH_RECOVERY_OPT=1
    set FLAG_TARGET_FILE=%TFS_ROOT%recovery.img

    if not exist "%FLAG_TARGET_FILE%" (
        call :input_flash_file
    )

    call :input_flash_recovery_opt

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0run_flash_recovery_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_flash_recovery_single.cmd"
            )

        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_main_menu
    pause > nul
exit /b 0
::
::
:input_flash_file
    call :view_input_flash_file
    set FLAG_TARGET_FILE=
    set /p FLAG_TARGET_FILE=
    if "%FLAG_TARGET_FILE%" == "" (
        call :view_wrong_enter_wrong_tip
        ping 127.0.1 -n 2 >nul 2>nul
        goto :input_flash_file
    )
    if not exist "%FLAG_TARGET_FILE%" (
        call :view_wrong_enter_wrong_tip
        ping 127.0.1 -n 2 >nul 2>nul
        goto :input_flash_file
    )
exit /b 0
::
::
:input_flash_recovery_opt
    call :view_input_flash_recovery_opt_tips
    call :view_press_key_num
    set selection=
    set /p selection=
    if /i "%selection%"=="1" cls && set "FLAG_FLASH_RECOVERY_OPT=1" && exit /b 0
    if /i "%selection%"=="2" cls && set "FLAG_FLASH_RECOVERY_OPT=2" && exit /b 0
    cls && goto :input_flash_recovery_opt
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_sub_run_flash_recovery_t
    set title_name=%title% %version% - Flash Menu ^( Flashing RECOVERY image ^)
exit /b 0
::
:view_flash_recovery_tips
    echo ================================================================================
    echo                                          NOTE:
    echo ================================================================================
    echo. [*] Help you flash Recovery image more easily.
    echo. [*] Note: if Recovery image is TWRP, please rename it to "recovery.img" first.
    echo. [*] The computer needs to turn off "Hide extensions of known file types" to see the suffix.
    echo.
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_input_flash_recovery_opt_tips
    echo ================================================================================
    echo                             Flash Recovery Options
    echo ================================================================================
    echo. [1] Flash Recovery partition                 [2] Direct booting Recovery
    echo.
    echo. [*] Direct booting Recovery image is useful on devices that do not have real Recovery
    echo partition ^( E.g. Motorola Z2 Force ^).
    echo --------------------------------------------------------------------------------
    echo.
exit /b 0
::
:view_press_key_num
    echo|set /p="Please enter the option number: >>"
exit /b 0
::
:view_input_flash_file
    echo.
    echo|set /p="Please enter the image location and press Enter: >>"
exit /b 0
::
:view_wrong_enter_wrong_tip
    echo Wrong input, please re-enter.
exit /b 0
::
:view_press_key_continue
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul
exit /b 0
::
:view_processing_device
    echo.
    echo Processing device: [%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [Fatal] Device list not found^^!
exit /b 0
::
:view_press_any_key_return_main_menu
    echo.
    echo Press any key to return to the Main menu.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
