@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:sub_run_get_deviceinfo
call :view_sub_run_get_deviceinfo_t
@title %title_name%

    call "%~dp0enumerate_fb_devices.cmd"

    if "%DEVICE_LIST%" NEQ "" (
        for %%d in (%DEVICE_LIST::= %) do (
            call :view_processing_device %%d
            set serial_number=%%d
            if "!DEVICE_COUNT!" == "1" (
                call "%~dp0run_get_deviceinfo_single.cmd"
            ) else (
                start cmd /k call "%~dp0run_get_deviceinfo_single.cmd"
            )
        )
    ) else (
        call :view_device_list_empty
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    call :view_press_any_key_return_main_menu
    pause > nul
exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_sub_run_get_deviceinfo_t
    set title_name=%title% %version% - Get Device Information
exit /b 0
::
:view_press_key_continue
    echo Please press any key to continue, or click the x button in the upper right corner to exit.
    pause > nul
exit /b 0
::
:view_processing_device
    echo.
    echo Processing device: [%1]
exit /b 0
::
:view_device_list_empty
    color fc
    echo.
    echo [Fatal] Device list not found^^!
exit /b 0
::
:view_press_any_key_return_main_menu
    echo.
    echo Press any key to return to the Main menu.
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
:exit
exit
